import * as React from 'react';
import toCsv, { ICsvProps } from './lib/csv';
export { toCsv, ICsvProps };
export type PrefixSuffix = boolean | string | number;
export interface ICsvDownloadProps extends ICsvProps, Omit<React.HTMLAttributes<HTMLDivElement | HTMLButtonElement>, 'prefix'> {
    bom?: boolean;
    filename: string;
    extension?: string;
    prefix?: PrefixSuffix;
    suffix?: PrefixSuffix;
    text?: string;
    disabled?: boolean;
    meta?: boolean;
    handleError?: (err: unknown) => void;
    handleEmpty?: () => void;
    title?: string;
}
export default class CsvDownload extends React.Component<ICsvDownloadProps> {
    handleClick: () => Promise<void>;
    render(): React.JSX.Element;
}
