export interface IColumn {
    displayName?: string;
    id: string;
}
export type ColumnsDefinition = (string | IColumn)[];
export type Columns = ColumnsDefinition | undefined | false;
export type Datas = (string[] | {
    [key: string]: string | number | null | undefined;
})[];
export interface ICsvProps {
    columns?: Columns;
    datas: Datas | (() => Datas) | (() => Promise<Datas>) | Promise<Datas>;
    separator?: string;
    noHeader?: boolean;
    wrapColumnChar?: string;
    newLineAtEnd?: boolean;
    chunkSize?: number;
    title?: string;
}
export default function csv({ columns, datas, separator, noHeader, wrapColumnChar, newLineAtEnd, chunkSize, title, }: ICsvProps): Promise<string | void>;
